package com.huimv.eartag2.manage2.controller;


import com.huimv.eartag2.common.common.token.TokenSign;
import com.huimv.eartag2.common.utils.Result;
import com.huimv.eartag2.manage2.service.EartagAbnormalAlarmService;
import com.huimv.eartag2.manage2.service.FarmerAssetService;
import com.huimv.eartag2.manage2.service.IEartagData2Service;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;

import org.springframework.web.bind.annotation.RestController;

import javax.servlet.http.HttpServletRequest;
import java.text.ParseException;
import java.util.Map;

/**
 * <p>
 *  前端控制器
 * </p>
 *
 * @author zn
 * @since 2022-08-30
 */
@RestController
@RequestMapping("/pig")
public class EartagAbnormalAlarmController {
    @Autowired
    private EartagAbnormalAlarmService eartagAbnormalAlarmService;
    @Autowired
    private FarmerAssetService farmerAssetService;

    @PostMapping("/getEarTemWarning")
    public Result getEarTemWarning(@RequestBody Map<String, Object> paramsMap) throws ParseException {
        return eartagAbnormalAlarmService.getEarTemWarning(paramsMap);
    }


    @PostMapping("/listFarmer")
    public Result listFarmer() throws ParseException {
        return eartagAbnormalAlarmService.listFarmer();
    }
    @PostMapping("/getNewPig")
    public Result getNewPig(@RequestBody Map<String, String> paramsMap) throws ParseException {
        return eartagAbnormalAlarmService.getNewPig(paramsMap);
    }

    @PostMapping("/getAssetStatistics")
    public Result getAssetStatistics(@RequestBody Map<String, Object> paramsMap) throws ParseException {
        return farmerAssetService.getAssetStatistics(paramsMap);
    }

    @PostMapping("/countAll")
    public Result countAll(@RequestBody Map<String, Object> paramsMap)   {
        return eartagAbnormalAlarmService.countAll(paramsMap);
    }

    @PostMapping("/pigMonitor")
    public Result pigMonitor(@RequestBody Map<String, Object> paramsMap)  {
        return eartagAbnormalAlarmService.pigMonitor(paramsMap);
    }

    @PostMapping("/getFarmerAndPig")
    public Result getFarmerAndPig(@RequestBody Map<String, Object> paramsMap)  {
        return eartagAbnormalAlarmService.getFarmerAndPig(paramsMap);
    }

    @Autowired
    private IEartagData2Service eartagDataService;
    @PostMapping("/getEnvByTime")
    public Result getEnvByTime(@RequestBody Map<String,String> map, HttpServletRequest request){

        return eartagDataService.getEnvByTimePanan(map);
    }

}

