package com.huimv.eartag2.manage2.service.impl;

import cn.hutool.core.util.ObjectUtil;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.StringUtils;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.huimv.eartag2.common.utils.Result;
import com.huimv.eartag2.common.utils.ResultCode;
import com.huimv.eartag2.manage2.mapper.BaseFarmerMapper;
import com.huimv.eartag2.manage2.mapper.EartagDeviceRegisterMapper;
import com.huimv.eartag2.manage2.mapper.SysAccountMultilevelMapper;
import com.huimv.eartag2.manage2.pojo.*;
import com.huimv.eartag2.manage2.mapper.EartagEartagRegister2Mapper;
import com.huimv.eartag2.manage2.service.IEartagEartagRegister2Service;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * <p>
 *  服务实现类
 * </p>
 *
 * @author author
 * @since 2022-08-04
 */
@Service
public class EartagEartagRegister2ServiceImpl extends ServiceImpl<EartagEartagRegister2Mapper, EartagEartagRegister2> implements IEartagEartagRegister2Service {

    @Autowired
    SysAccountMultilevelMapper sysAccountMultilevelMapper;

    @Override
    public Result listFarmUnitEartagData(Map<String, String> params) {
        String pageSize = params.get("pageSize");
        String pageNo = params.get("pageNo");
        String unitId = params.get("unitId");
        String deviceCode = params.get("deviceCode");
        String farmId = params.get("farmId");
        String earmark = params.get("earmark");
        String liveStatus = params.get("liveStatus");
        String userId = params.get("userId");
        SysAccountMultilevel user = sysAccountMultilevelMapper.selectById(userId);
        if (StringUtils.isBlank(pageNo)){
            pageNo="1";
        }
        if (StringUtils.isBlank(pageSize)){
            pageSize="20";
        }
        Float maxEarTemp = 0F;
        Float minEarTemp = 100F;
        QueryWrapper<EartagEartagRegister2> wrapper = new QueryWrapper<>();
        //客户数据
       /* if (user.getIsUser() == 0){
            wrapper.between("ear_temp1",30,40);
            wrapper.le("act",10000);
            wrapper.eq("live_status", 1);
        }*/
        //设备
        wrapper.like(StringUtils.isNotBlank(deviceCode),"last_device",deviceCode);
        wrapper.eq("farm_id",farmId);
        wrapper.eq(StringUtils.isNotBlank(unitId),"unit_id",unitId);
        wrapper.like(StringUtils.isNotBlank(earmark),"earmark",earmark);
        wrapper.eq(StringUtils.isNotBlank(liveStatus),"live_status",liveStatus);
        wrapper.orderByDesc("ask_time");
        //大堰河牧场过滤
        if ("330112004".equals(farmId)){
            wrapper.eq("live_status", 1).and( i->i.likeRight("earmark","1332022109003").or().likeRight("earmark","1332022109004"));
        }
        Page<EartagEartagRegister2> page = this.page(new Page<>(Long.parseLong(pageNo), Long.parseLong(pageSize)), wrapper);
        if (user.getIsUser() == 0){
         for (EartagEartagRegister2 record : page.getRecords()) {
            Float earTemp1 = record.getEarTemp1();
            Long act = record.getAct();
                if (earTemp1 >40){
                    record.setEarTemp1(40F);
                }
                if (earTemp1 <30){
                    record.setEarTemp1(30F);
                }
                if (act >300){
                    record.setAct(300L);
                }
                if (act<0){
                    record.setAct(0L);
                }
            }
        }
        Map map = new HashMap();
        long allCount = this.count(wrapper);
        //在线
        if (!"330112004".equals(farmId)){
            wrapper.eq("live_status", 1);
        }
        long onCount = this.count(wrapper);
        List<EartagEartagRegister2> list = this.list(wrapper);
        if (list.size() == 0){
            minEarTemp = 0F;
        }
        for (EartagEartagRegister2 record : list) {
            Float earTemp1 = record.getEarTemp1();
            Long act = record.getAct();
            //客户数据
            if (user.getIsUser() == 0){
                if (earTemp1 >40){
                    earTemp1 = 40F;
                }
                if (earTemp1 <30){
                    earTemp1 = 30F;
                }
            }
            maxEarTemp = Math.max(earTemp1,maxEarTemp);
            minEarTemp = Math.min(earTemp1,minEarTemp);
        }
        map.put("countOff",allCount-onCount);
        map.put("countOn",onCount);
        map.put("countAll",allCount);
        map.put("maxEarTemp",maxEarTemp);
        map.put("minEarTemp",minEarTemp);
        map.put("page",page);
        return new Result(ResultCode.SUCCESS,map);
    }

    @Override
    public Result listFarmUnitEartagData2(Map<String, String> params) {
        String pageSize = params.get("pageSize");
        String pageNo = params.get("pageNo");
        String unitId = params.get("unitId");
        String deviceCode = params.get("deviceCode");
        String farmId = params.get("farmId");
        String earmark = params.get("earmark");
        String liveStatus = params.get("liveStatus");
        String userId = params.get("userId");
//        SysAccountMultilevel user = sysAccountMultilevelMapper.selectById(userId);
        if (StringUtils.isBlank(pageNo)){
            pageNo="1";
        }
        if (StringUtils.isBlank(pageSize)){
            pageSize="20";
        }
        Float maxEarTemp = 0F;
        Float minEarTemp = 100F;
        QueryWrapper<EartagEartagRegister2> wrapper = new QueryWrapper<>();
        //客户数据
       /* if (user.getIsUser() == 0){
            wrapper.between("ear_temp1",30,40);
            wrapper.le("act",10000);
            wrapper.eq("live_status", 1);
        }*/
        //设备
        wrapper.like(StringUtils.isNotBlank(deviceCode),"last_device",deviceCode);
        wrapper.eq("farm_id",farmId);
        wrapper.eq(StringUtils.isNotBlank(unitId),"unit_id",unitId);
        wrapper.like(StringUtils.isNotBlank(earmark),"earmark",earmark);
        wrapper.eq(StringUtils.isNotBlank(liveStatus),"live_status",liveStatus);
        wrapper.orderByDesc("ask_time");
        //大堰河牧场过滤
        if ("330112004".equals(farmId)){
            wrapper.eq("live_status", 1).and( i->i.likeRight("earmark","1332022109003").or().likeRight("earmark","1332022109004"));
        }
        Page<EartagEartagRegister2> page = this.page(new Page<>(Long.parseLong(pageNo), Long.parseLong(pageSize)), wrapper);
//        if (user.getIsUser() == 0){
            for (EartagEartagRegister2 record : page.getRecords()) {
                Float earTemp1 = record.getEarTemp1();
                Long act = record.getAct();
                if (earTemp1 >40){
                    record.setEarTemp1(40F);
                }
                if (earTemp1 <30){
                    record.setEarTemp1(30F);
                }
                if (act >300){
                    record.setAct(300L);
                }
                if (act<0){
                    record.setAct(0L);
                }
            }
//        }
        Map map = new HashMap();
        long allCount = this.count(wrapper);
        //在线
        if (!"330112004".equals(farmId)){
            wrapper.eq("live_status", 1);
        }
        long onCount = this.count(wrapper);
        List<EartagEartagRegister2> list = this.list(wrapper);
        if (list.size() == 0){
            minEarTemp = 0F;
        }
        for (EartagEartagRegister2 record : list) {
            Float earTemp1 = record.getEarTemp1();
            Long act = record.getAct();
            //客户数据
//            if (user.getIsUser() == 0){
//                if (earTemp1 >40){
//                    earTemp1 = 40F;
//                }
//                if (earTemp1 <30){
//                    earTemp1 = 30F;
//                }
//            }
            maxEarTemp = Math.max(earTemp1,maxEarTemp);
            minEarTemp = Math.min(earTemp1,minEarTemp);
        }
        map.put("countOff",allCount-onCount);
        map.put("countOn",onCount);
        map.put("countAll",allCount);
        map.put("maxEarTemp",maxEarTemp);
        map.put("minEarTemp",minEarTemp);
        map.put("page",page);
        return new Result(ResultCode.SUCCESS,map);
    }

    @Autowired
    private EartagDeviceRegisterMapper eartagDeviceRegisterMapper;

    @Override
    public Result listFarmUnitEartagDataByFarmer(Map<String, String> params) {
        String pageSize = params.get("pageSize");
        String pageNo = params.get("pageNo");
        String deviceCode = params.get("deviceCode");
        String farmId = params.get("farmId");
        String earmark = params.get("earmark");
        String farmerId = params.get("farmerId");
        String liveStatus = params.get("liveStatus");
        if (StringUtils.isBlank(pageNo)){
            pageNo="1";
        }
        if (StringUtils.isBlank(pageSize)){
            pageSize="20";
        }
        Map map = new HashMap();
        List<EartagDeviceRegister> eartagDeviceRegisters = eartagDeviceRegisterMapper.selectList(new QueryWrapper<EartagDeviceRegister>().eq("farmer_id", farmerId));
        if (ObjectUtil.isEmpty(eartagDeviceRegisters) || eartagDeviceRegisters.size() == 0){
            map.put("countOff",0);
            map.put("countOn",0);
            map.put("countAll",0);
            map.put("maxEarTemp",0);
            map.put("minEarTemp",0);
            map.put("page",new Page<EartagEartagRegister2>());
            return new Result(ResultCode.SUCCESS,map);
        }
        List farmerIds = new ArrayList();
        for (EartagDeviceRegister eartagDeviceRegister : eartagDeviceRegisters) {
            farmerIds.add(eartagDeviceRegister.getDeviceCode());
        }


        Float maxEarTemp = 0F;
        Float minEarTemp = 100F;
        QueryWrapper<EartagEartagRegister2> wrapper = new QueryWrapper<>();
        //设备
        wrapper.like(StringUtils.isNotBlank(deviceCode),"last_device",deviceCode);
        wrapper.eq("farm_id",farmId);
        wrapper.like(StringUtils.isNotBlank(earmark),"earmark",earmark);

        wrapper.eq(StringUtils.isNotBlank(liveStatus),"live_status",liveStatus);
        wrapper.orderByDesc("ask_time");
        wrapper.in("last_device",farmerIds);
        //屏蔽不合格耳标
        wrapper.le("ear_temp1",50);


        Page<EartagEartagRegister2> page = this.page(new Page<>(Long.parseLong(pageNo), Long.parseLong(pageSize)), wrapper);


        long allCount = this.count(wrapper);

        //在线
        wrapper.eq("live_status", 1);
        long onCount = this.count(wrapper);
        List<EartagEartagRegister2> list = this.list(wrapper);
        if (list.size() == 0){
            minEarTemp = 0F;
        }
        for (EartagEartagRegister2 record : list) {
            Float earTemp1 = record.getEarTemp1();
            //吴老师要求，屏蔽耳标
            maxEarTemp = Math.max(earTemp1,maxEarTemp);

            minEarTemp = Math.min(earTemp1,minEarTemp);
        }


        map.put("countOff",allCount-onCount);
        map.put("countOn",onCount);
        map.put("countAll",allCount);
        map.put("maxEarTemp",maxEarTemp);
        map.put("minEarTemp",minEarTemp);
        map.put("page",page);

        return new Result(ResultCode.SUCCESS,map);
    }

}
