package com.huimv.eartag2.manage2.service.impl;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.StringUtils;
import com.huimv.eartag2.common.utils.DateUtil;
import com.huimv.eartag2.common.utils.Result;
import com.huimv.eartag2.common.utils.ResultCode;
import com.huimv.eartag2.manage2.pojo.EartagHourAct;
import com.huimv.eartag2.manage2.pojo.EartagResetCount;
import com.huimv.eartag2.manage2.mapper.EartagResetCountMapper;
import com.huimv.eartag2.manage2.service.EartagResetCountService;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.text.ParseException;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * <p>
 *  服务实现类
 * </p>
 *
 * @author zn
 * @since 2022-08-12
 */
@Service
public class EartagResetCountServiceImpl extends ServiceImpl<EartagResetCountMapper, EartagResetCount> implements EartagResetCountService {

    @Autowired
    private EartagResetCountMapper eartagResetCountMapper;

    @Override
    public Result getEartagResetCount(String farmCode, String startDate, String endDate, String earmark) throws ParseException {
        QueryWrapper<EartagResetCount> queryWrapper= new QueryWrapper<>();
        queryWrapper.eq(StringUtils.isNotBlank(farmCode),"farm_code",farmCode);
        queryWrapper.between("add_date",startDate,endDate);
        queryWrapper.eq(StringUtils.isNotBlank(earmark),"earmark",earmark);
        queryWrapper.orderByAsc("add_date");
        List<EartagResetCount> eartagResetCountList = eartagResetCountMapper.selectList(queryWrapper);
        List resultList = new ArrayList();
        DateUtil du = new DateUtil();
        for(EartagResetCount artagResetCount:eartagResetCountList){
            Map map = new HashMap<>();
            resultList.add(map);
            map.put("addDate",du.formatDateText(artagResetCount.getAddDate()));
            map.put("times",artagResetCount.getTimes());
        }
        return new Result(ResultCode.SUCCESS,resultList);
    }
}
